/* JavaScript Outline
 *   2010/4/25 ver 1.0 
 */
Outline.SetTitle( "JavaScriptAEgC" );
Outline.SetListType( 100 );	//ėpc[
var line_max = Editor.GetLineCount( 0 );	//s
var indent_unit = Editor.ChangeTabWidth( 0 );	//Cfgĩ݂^uj
var tabSpace = "        ".substr(0, indent_unit);

var extending = [];	//g̗vf
function setExtending(level, target) {	//g̗vfݒ
	extending[level] = target;
	for (var i=level+1; i<extending.length; i++) {
		extending[i] = null;
	}
}
var in_comment = false;	//Rg?
var in_paren_abbrev = false;	//iffor̔gʏȗ?
var in_ternary_operator = false;	//OZq?ŏI?
var in_ternary_operator2 = false;	//OZq?̎?
var block_level = 0;	//\ɂCfg
var in_level_down = false;	//Kw
var down_level = 0;	//Kw臃x

//ҏW1sǂݍŉ͂
for ( var line_no = 1; line_no <= line_max; line_no++ ) {
	var line_str = Editor.GetLineStr( line_no );
	line_str = line_str.replace(/[\r\n]+$/, "");	//EOL菜

	// sRg폜
	line_str = line_str.replace(/\/\*.*?\*\//g, "");
	line_str = line_str.replace(/\/\/.*$/g, "");
	if (/^\s*$/.test(line_str)) {
		continue;	//s͔΂
	}
	//Cfg擾A\tXy[Xϊ
	var indent = line_str.replace(/^(\s*).*$/, "$1");
	var column = indent.length+1;
	if (indent.length > 0) {
		indent = indent.replace(/\t/g, tabSpace);
		if (indent.length == 2) {
			indent_unit = 2;
		}
	}
	var indent_real  = indent.length/indent_unit;	//Cfgi^uZj
	if (indent_real < block_level) block_level = 0;
	var indent_level = indent_real
					 - block_level					//ubNCfg
					 - (in_paren_abbrev ? 1 : 0);	//ubNCfgigʏȗj

	in_paren_abbrev = false;

	// sRg̏
	if (/^\s*\/\*/.test(line_str)) {
		in_comment = true;
		if (/\*\/\s*$/.test(line_str)) {
			in_comment = false;
		}
		continue;
	}
	else if (/\*\/\s*$/.test(line_str)) {
		in_comment = false;
		continue;
	}
	else if (in_comment) {
		continue;
	}

	if (in_level_down) {
		if (indent_level <= down_level && ! /^\s*$/.test(line_str)) {
			in_level_down = false;
		} else {
			indent_level++;
		}
	}

	//OZq ? ōsIĂ邩ǂ
	in_ternary_operator2 = in_ternary_operator;
	in_ternary_operator = /\?\s*$/.test(line_str);

	//\CfgɑΉ
	if (/^\s*}?\s*\b(if|else|try|for|while|catch)\b.*\)\s*$/.test(line_str)) {
		in_paren_abbrev = true;
		continue;
	}
	if (/^\s*}?\s*\b(if|else|try|for|while|catch)\b.*{/.test(line_str)  &&  ! /{.*}/.test(line_str)) {
		if (! /^\s*}/.test(line_str)) {
			block_level ++;
		}
		continue;
	}
	else if (/^\s*}/.test(line_str) && block_level > 0) {
		block_level --;
		continue;
	}

	// function xxxx ̏
	if (/^\s*function\s+[\w\$]+.*$/.test(line_str)) {
		var name = line_str.replace(/^\s*function\s+([\w\$]+).*$/, "$1");
		var arg = line_str.replace(/^\s*function\s+[\w\$]+\s*\(([^\)]*).*$/, "$1").replace(/^\s*/, " ").replace(/\s*$/, " ").replace(/\s*,\s*/g, ", ");
		Outline.AddFuncInfo2( line_no, column, name + " (" + arg + ") ֐", indent_level );
		setExtending(0, null);
//		TraceOut(name + " indent_level:" + indent_level + " block_level:" + block_level + " indent_real:" + indent_real);
	}
	// var xxxx = { ̏
	else if (/^\s*var\s+[\w\$]+\s*=\s*({\s*|\(\s*function\s*\(.*)$/.test(line_str)) {
		var name = line_str.replace(/^.*\s+([\w\$]+)\s*=.*$/, "$1");
		Outline.AddFuncInfo2( line_no, column, name + " IuWFNg", indent_level );
		setExtending(indent_level, name);
	}
	else if (/^\s*[\w$.]+\s*=\s*({\s*|\(\s*function\s*\(.*)$/.test(line_str)) {
		var name = line_str.replace(/^\s*([\w$.]+)\s*=.*$/, "$1");
		Outline.AddFuncInfo2( line_no, column, name + " IuWFNg", indent_level );
		setExtending(indent_level, name);
	}
	// return { ̏
	else if (/^\s*return\s*{\s*$/.test(line_str)) {
		Outline.AddFuncInfo2( line_no, column, "߂l", indent_level );
	}
	// xxxx : function() { ̏
	// xxxx = function() { ̏
	// var xxxx = function() { ̏
	else if (/^\s*(var\s)?\s*[\w$.]+\s*[:=]\s*function\s*\([^\)]*/.test(line_str)) {
		var name = line_str.replace(/^\s*(var\s)?\s*([\w$.]+)\s*[:=].*$/, "$2");
		var arg = line_str.replace(/^.*function\s*\(([^\)]*).*$/, "$1").replace(/^\s*/, " ").replace(/\s*$/, " ").replace(/\s*,\s*/g, ", ");
		var type = /=\s*function/.test(line_str) ? "֐" : "\bh";
		var lastDot = name.lastIndexOf('.');
		if (in_ternary_operator2 && type == "\bh") {
			//OZq?̎ xxxx: ĂA̓\bhȂ
		} else if (lastDot < 0) {
			Outline.AddFuncInfo2( line_no, column, name + " (" + arg + ") " + type, indent_level );
			setExtending(indent_level, null);
		} else {
			var extend_target = name.substring(0, lastDot);
			if (extend_target != extending[indent_level]) {
				Outline.AddFuncInfo2( line_no, column, extend_target + " g", indent_level );
				setExtending(indent_level, extend_target);
			}
			Outline.AddFuncInfo2( line_no, column, name.substring(lastDot+1) + " (" + arg + ") \bh", indent_level+1 );
			setExtending(indent_level+1, name);
			down_level = indent_level;
			in_level_down = true;
		}
	}
	// xxxx : ̏
	else if (/^\s*case\s+[\w\$]+\s*:/.test(line_str)	//case
		  || /^\s*default\s*:/.test(line_str)			//default
		  || /^\s*[a-z]+:\/\//.test(line_str)			//URL
	) {
		//vpeBȂ
	}
	else if (/^\s*['"]?[\w$.]+["']?\s*:/.test(line_str)) {
		//OZq?̎ xxxx: ĂA̓vpeBȂ
		if (! in_ternary_operator2) {
			var name = line_str.replace(/^\s*['"]?([\w$.]+)["']?\s*:.*$/, "$1");
			Outline.AddFuncInfo2( line_no, column, name + " vpeB", indent_level );
		}
	}
	else if (/^\s*[\w$.]+\s*=(?!=)/.test(line_str)) {
		var name = line_str.replace(/^\s*([\w$.]+)\s*=.*$/, "$1");
		var lastDot = name.lastIndexOf('.');
		if (lastDot < 0) {
			//̕ϐȂ̂ŒǉȂ
		} else {
			var extend_target = name.substring(0, lastDot);
			if (extend_target != extending[indent_level]) {
				Outline.AddFuncInfo2( line_no, column, extend_target + " g", indent_level );
				setExtending(indent_level, extend_target);
			}
			Outline.AddFuncInfo2( line_no, column, name.substring(lastDot+1) + " vpeB", indent_level+1 );
		}
	}
	// (function() { ̏
	else if (/^\s*;*\(\s*function\s*\([^\)]*\)\s*{/.test(line_str)) {
		if (extending[0] != "ubN") {
			Outline.AddFuncInfo2( line_no, column, "ubN", indent_level );
			setExtending(indent_level, "ubN");
		}
	}

	// for prototype.js
	// Object.extend ̏
	else if (/^\s*(var\s)?\s*[\w$.]+\s*=\s*Object\.extend\(/.test(line_str)) {
		var name = line_str.replace(/^.*\b([\w$.]+)\s*=.*$/, "$1");
		Outline.AddFuncInfo2( line_no, column, name + " IuWFNg", indent_level );
	}
	else if (/^\s*.*(Object\.)?extend\(\s*[\w$.]+\s*,/.test(line_str)) {
		var name = line_str.replace(/^\s*.*extend\(\s*([\w$.]+).*$/, "$1");
		if (name != extending[indent_level]) {
			Outline.AddFuncInfo2( line_no, column, name + " g", indent_level );
			setExtending(indent_level, name);
		}
	}
	// Class.create ̏
	else if (/^\s*(var\s)?\s*[\w\$]+\s*=\s*Class\.create\s*\(/.test(line_str)) {
		var name = line_str.replace(/^.*\b([\w\$]+)\s*=.*$/, "$1");
		Outline.AddFuncInfo2( line_no, column, name + " NX", indent_level );
		//Class.createz̗vf̓CX^Xɕt̂ŁA(NX).xxxƂ͋ʂ
		//setExtending(indent_level, name);
	}

	// for jQuery
	// jQuery.extend, jQuery.fn.extend̏
	else if (/^\s*jQuery\.extend\(/.test(line_str)) {
		if (extending[0] != "jQuery") {
			Outline.AddFuncInfo2( line_no, column, "jQuery g", 0 );
			setExtending(0, "jQuery");
		}
	}
	else if (/^\s*jQuery\.fn\.extend\(/.test(line_str)) {
		if (extending[0] != "jQuery.prototype") {
			Outline.AddFuncInfo2( line_no, column, "jQuery.prototype g", 0 );
			setExtending(0, "jQuery.prototype");
		}
	}
	else if (/^\s*jQuery\.each\(.*[{\[]\s*$/.test(line_str)) {
		if (extending[0] != "jQuery.prototype") {
			Outline.AddFuncInfo2( line_no, column, "jQuery.each ubN", indent_level );
			setExtending(indent_level, "ubN");
		}
	}

	// for dojo
	// dojo.mixin̏
	else if (/^\s*(dojo|d)\.mixin\(\s*[\w$.]+/.test(line_str)) {
		var extend_target = line_str.replace(/^.*\bmixin\(\s*([\w$.]+).*$/, "$1");
		if (extend_target != extending[indent_level]) {
			Outline.AddFuncInfo2( line_no, column, extend_target + " g", indent_level );
			setExtending(indent_level, extend_target);
		}
	}
	else if (/^\s*(var\s)?\s*[\w$.]+\s*=\s*(dojo|d)\.mixin\(/.test(line_str)) {
		var target = line_str.replace(/^\s*(var\s)?\s*([\w$.]+)\s*=.*$/, "$2");
		Outline.AddFuncInfo2( line_no, column, target + " IuWFNg", indent_level );
		setExtending(indent_level, target);
	}

}

